import shapefile

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

from shapely.geometry import *
import sys
import matplotlib.pyplot as pyplot

#make a point shape file

#p1 = Point(0.5,0.5)

poly = Polygon([(-170,-6),(-170,72),(-54,72),(-54,-6),(-170,-6)])

#print(p1.within(poly))


#check if the number of command  line arguments are 
#ok

#assert len(sys.argv)==4, "Incorrect Number of Arguments passed"


"""
Sets the read and the write file stream according to
the command line arguments given.

The first argument specifies which shape file the user
wants to specify the boundaries of

The second arguments specifies the boundary polygon

The third argument specifies the file path to which the
new shape has top be written

"""

readPath = sys.argv[1]
#boundaryPath = sys.argv[2]
#writePath = sys.argv[3]

#input stream for the given shape
sf = shapefile.Reader(readPath)

#input stream of the boundaries
#bounds = shapefile.Reader(boundaryPath)

#output stream for the new file containing the shape only within the boundaries
write = shapefile.Writer()

#shapes contained in the given file
shapes = sf.shapes();

#checks that there shouldonly be one boudary
#assert len(bounds.shapes())==1, "More than one shape in the boundary. Currently only one shape can be specified as a boundary"

#boundary = bounds.shapes[0]
boundary = poly


# Create list of the points defined in the .shp file.
pointslist = []
for i in range(len(shapes)):
	# Check datapoint is valid.
	pointslist.append(shapes[i].points)

boundaryPoints = list(boundary.exterior.coords)


"""
	This function checks if the given point is on the boundary.
	@param point : specifies the point which has to be checked
	@param bouds : specifies all the bpundary objects
	@return			 : returns true iff the point in on the boundary lines
"""
def checkPointOnBoundary(point, bounds):
		if (point.x,point.y) in boundaryPoints:
			return True
	#for s in bounds.shapes():
		points = bounds.exterior.coords
		numberOfPoints = len(points)
		for i in range(numberOfPoints-1):
			line = LineString([(points[i][0],points[i][1]),(points[i+1][0], points[i+1][1])])
			if (line.contains(point)):
				return True
		return False
	
i = -1
c = 1
for shape in shapes:
	i += 1
	for point in pointslist[i]:
		p = Point(point[0],point[1])
		if p.within(boundary) or checkPointOnBoundary(p,boundary,) :
			write.point(p.x,p.y)
			write.field('%d_FLD' % c)
		c +=1


#if write==null: 
print("\n\n number of shapes = %d" % len(write.shapes()))
#write.save('test')
coords = []
for s in write.shapes():
	for p in s.points:
		print(p)
		coords.append((p[0],p[1]))

#print the points of the polygon on a graph

# Store x-y coords of the perimeter in two lists to plot.
x = []; y = []
for i in range(len(coords)):
	x.append(coords[i][0]); y.append(coords[i][1])

# Plot results.
pyplot.plot(x, y)
#pyplot.xlim(-4, 4)
#pyplot.ylim(-4, 4)
pyplot.show()
