#Function to write .shp files. Read these files in new function, use shapely to work out overlap. Output this new shape to .geo using another function.

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

##########################################################################
#  
#  Generation of boundary representation from arbitrary geophysical
#  fields and initialisation for anisotropic, unstructured meshing.
#  
#  Copyright (C) 2011-2013 Dr Adam S. Candy, adam.candy@imperial.ac.uk
#  
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#  
##########################################################################

from shapely.geometry import Polygon, Point
from shapely.ops import cascaded_union
from matplotlib import pyplot
import shapefile
import sys

def getPointsList(filename):
	bounds = shapefile.Reader(filename)
	shape = bounds.shapes()[0]
	points = shape.points
	splitPoints = shape.parts
	pointsList = []
	print(splitPoints)
	print(points)
	print(len(points))
	for i in range(len(splitPoints)-1):
# print("i-->%d"%i)
#	print("s1-->%d"%splitPoints[i])
#	print("s2-->%d"%splitPoints[i+1])
		pointsList.append(points[splitPoints[i]:splitPoints[i+1]] )
	"""
	for i in range(len(shapes)):
		pointsList.append(shapes[i].points)
	polygons = []
	for j in range(len(pointsList)):
		if len(pointsList[j])>3 : polygons.append(Polygon([pointsList[j][i] for i in range(len(pointsList[j]))]))
	"""
	return pointsList


# Write new shape to .geo.
def write_geo (coords, filename):
	target = open("%s.geo" % filename, "w") # Creates .geo file to write to.
	i = 0
	for l in coords:
		# Write point.
		for p in l:
			i +=1
			target.write('Point(%d) = {%f, %f, 0, 1.0};\n' %(i, p[0], p[1]))
		# Write the lines connecting the sequential points.
	print	
	i=0
	c = 0
	surface = "Plane Surface(1) = {"
	for k in range(len(coords)):
		l = coords[k]
		i+=1
		lineloop = "Line Loop(%d) = {" % i
		if len(l) > 1 :
			print("surface --> >>%s<<"%surface)
			for j in range(len(l)-1) :
				target.write("Line(%d) = {%d,%d};\n"%((j+c+1),(c+j+1),(j+c+2)))
				lineloop = lineloop + str(j+c+1) + ", "
			target.write("Line(%d) = {%d,%d};\n"%((c+len(l)),(c+ len(l)),(c+1)))
			lineloop = lineloop + ("%d};\n"%(len(l)+c))
			target.write(lineloop)
			surface = surface + str(i) + ", "
		c+=len(l)
	print(len(surface))
	if len(surface)!= 20 : surface = surface[0:len(surface)-2]
	surface = surface + "};\n"
	target.write(surface)
	target.close()
			
def printErrorMessage():
	print("\nIncorrect Number of arguments Passed\nProgram Usage:\n>>>python makeGeoFile.py <path of shapefile to be read> <path of the geo file to be written>\n")

assert len(sys.argv)==3, printErrorMessage()
print("Writing the file")
readPath = sys.argv[1]
writePath = sys.argv[2]
print(getPointsList(readPath))
write_geo(getPointsList(readPath), writePath)
print("File has been written")
